--[[
	-        PtokaX.
	-    .
	-      ,         .
	-   , www  wWw   (          cp1251   ).
	-           (    ,
		         ).
	-        .
	-       (        ).
	-      :      (  ),
		 (     disconnect),     (    ,
		   ),   ( ,      ,
		        )       .
	-           (  ,   ).
	-       ,    .
	-    - (tProfiles)   .
	-       .
	
	    ,       lua.

            :  Damaks     nd
			:  1.6
            :  PtokaX 0.4,  Lua 5.1,   API2
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	+ Mod by  6.02.2012
		 //        +       ().
	+   . :)
	 Core.SendPmToUser(user, to,"***  "..block_message[1]) -    block_message[1]   .
		?        ,     :).
		        ,  to  sBot 
	+ 14.02.2012       . by alex82
	+ 22.06.2013       .
	]]

-------------------------------[ Preference ]-------------------------------
sPathToForbPat = Core.GetPtokaXPath().."scripts/Antiadv/Forbidden.dat"
sPathToAllowedPat = Core.GetPtokaXPath().."scripts/Antiadv/Allowed.dat"
sPathToConf = Core.GetPtokaXPath().."scripts/Antiadv/Conf.dat"
sPathToAntimat = Core.GetPtokaXPath().."scripts/Antiadv/Antimat.dat"  -- 
sPathToExToAntimat = Core.GetPtokaXPath().."scripts/Antiadv/Exceptions_to_antimat.dat"  -- 
----------------------------------------------------------------------------
local tProfiles = {      --  ,    (1 -  (      ); 0 - )
   [0] = 1,      -- 
   [1] = 1,      -- 
   [2] = 1,      -- 
   [3] = 1,      --  
   [4] = 0,      -- VIP
  [-1] = 0,      --  
}
local tControl = {	--,    
	[0] = 1,    -- 
}
local Log = Core.GetPtokaXPath().."scripts/Antiadv/Logs.txt"  --    
local sHubName = SetMan.GetString(0) --  
local MenuAdm = " " --   ,     20  ;)
local sBot = SetMan.GetString(21)      --  
local bot_reg = 0      --      (1 - , 0 - )
local sAdminMail = SetMan.GetString(30) or " \"E-mail     ,   \""-- E-mail ,    PtokaX

conf = {	--   
	ban_time = 10,      --   ()
	op_info = 1,      --          (1 - , 0 - )
	min_size = 5,      --   ,     ( - 8 ,  ,   5 )

	block_all_mode = 2,     --[[      :
	                                   0 -    ,    BanTime;
	                                   1 - ;
	                                   2 -   block_message[1];
	                                   3 -   (   ).
	                                   4 -   (   ,      .
	]]
	block_pm_mode = 2,       --[[     :
	                                   0 -    ,    BanTime;
	                                   1 - ;
	                                   2 -    block_message[1]    ;
	                                   3 -   (   ).
	                                   4 -   (   ,      ).
	]] 
}
	
forbidden_patterns = {      --   
	"d.?c.?h.?u.?b.?:.?/.?/", "d%p*c%p*h%p*u%p*b%p*:%p*/%p*/", "d%s*c%s*h%s*u%s*b%s*:%s*/%s*/",		--  "dchub://"  
	--"h.?t.?t.?p.?:.?/.?/", "h%p*t%p*t%p*p%p*:%p*/%p*/", "h%s*t%s*t%s*p%s*:%s*/%s*/",		--  "http://"  
	--"w.?w.?w.?%.",		--  "www."  
	"no%s?%-%s?ip", "%-%s?hub%s?%.%s?org", "dyndns%s?%.%s?tv", "%.%s?ucoz%s?%.",		--   ""    (*no-ip*, *-hub.org*, *dyndns.tv, *.ucoz.*)
	"%d+%.%d+%.%d+%.%d+",		--  ip-
	"%a%.ro%:?%d*%s+", "%a%.ro%:?%d*$", "%a%.ro%:?%d*/",		--  .ro
	--"%a%.ru%:?%d*%s+", "%a%.ru%:?%d*$", "%a%.ru%:?%d*/",		--  .ru
	--"%a%.ua%:?%d*%s+", "%a%.ua%:?%d*$", "%a%.ua%:?%d*/",		--  .ua
	"%a%.net%:?%d*%s+", "%a%.net%:?%d*$", "%a%.net%:?%d*/",		--  .net
	--"%a%.com%:?%d*%s+", "%a%.com%:?%d*$", "%a%.com%:?%d*/",		--  .com
}

allowed_patterns = {      --   
	"magnet:%?xt%S*",      --    -
	"%S*wikipedia%.org%S*%s*", "%S*youtube%.com%S*%s*", "%S*rutube%.ru%S*%s*", 
	"%S*smotri%.com%S*%s*",  "%S*radikal%.ru%S*%s*",  "%S*fastpic%.ru%S*%s*",      --   
	"prime-hub.ru:411", --   ,    ,  ,  .
}

antimat_pat = {	--    
	"[6][][]",
	"[xX]%s*%p*%s*[yY]%s*%p*%s*[eE]",
	"[][eE][3][]",
	"[ŸeE][6][aA]",
	"[][][][][]",
	"[eEŸ][6][aAyYeE]",
	
}

exceptions_pat = { --   
	"[][][][]",
	"[][][][][][][][]",
	"[][][][][][][][]",
	"[][][][][][]",
	"[][][][]",
	"[][][][][]",
	"[][][Ÿ][]",
	"[][][Ÿ][]",
	"[][Ÿ][6][Ÿ]",
	"[][][][][][]",
	"[][][][][][][][]",
	"[--][xX]%s*%p*%s*[yY]%s*%p*%s*[eE][--]",
	"[][]%s*[][cC][][xX][yY][]",
	"", "",
	"[][][][][][][][]",
	"[][][][][]",
	"[][][][][]",
	"[][][][][]",
	"[][][][][]",
	"[][][][][][eE][]",
	"[][][][][][]",
	"",
	"[]",
	"[][]",
	"[][][][][][][][][]",
	"[][][][][][][][][eE][tT]",
	"[][][][][][][][][][aA]",
	"[][][][][][][][][eE][b]",
	"[][][][]",
	"[][][][][]",
	"[][][][]",
	"[]][][][]", 
	"[][][][][][][][][][]",
}

local block_message = {      --  
	"!!!      "..sHubName.."   ,    !               ,       E-mail: "..sAdminMail.."  .",
	"!!!      "..sHubName.."   !     ",
	"!!!      "..sHubName.."   !   .",
	"     :  ",
	"      ",
}

function UserConnected(user)
	if tControl[user.iProfile] == 1 then
	Core.SendToUser(user, 
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\  /$<%[mynick]> !addForbPat %[line:   .]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\  /$<%[mynick]> !addAllPat %[line:   .]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\  /$<%[mynick]> !showForbPat &#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\  /$<%[mynick]> !showAllPat &#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\   /$<%[mynick]> !delForbPat %[line:  ]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\   /$<%[mynick]> !delAllPat %[line:  ]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ \\  (   ' ')$<%[mynick]> !advconf block_all_mode 0&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ \\$<%[mynick]> !advconf block_all_mode 1&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ \\ $<%[mynick]> !advconf block_all_mode 2&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ \\(  )$<%[mynick]> !advconf block_all_mode 3&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ \\$<%[mynick]> !advconf block_all_mode 4&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\\\  (   ' ')$<%[mynick]> !advconf block_pm_mode 0&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\\\$<%[mynick]> !advconf block_pm_mode 1&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\\\ $<%[mynick]> !advconf block_pm_mode 2&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\\\(  )$<%[mynick]> !advconf block_pm_mode 3&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\\\$<%[mynick]> !advconf block_pm_mode 4&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\ $<%[mynick]> !advconf ban_time %[line:   .]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\   ?$<%[mynick]> !advconf op_info %[line:1 - , 0 - ]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\\\  \\   $<%[mynick]> !advconf min_size %[line:- ]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\   $<%[mynick]> !showPat &#124;|"..
		--  
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\   /$<%[mynick]> !addMatPat %[line: ?]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\     /$<%[mynick]> !addGoodPat %[line: ?]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\   /$<%[mynick]> !showMatPat&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\     /$<%[mynick]> !showGoodPat&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\   /$<%[mynick]> !delMatPat %[line: ?]&#124;|"..
		"$UserCommand 1 3 "..MenuAdm.."\\\\ \\     /$<%[mynick]> !delGoodPat %[line: ?]&#124;|"
	)
	end
end
OpConnected = UserConnected
RegConnected = UserConnected
------------------------------[ Code Section ]------------------------------


function OnStartup()
	if bot_reg==1 then
		Core.RegBot(sBot,"Mod by ","",true) --   ,  "Mod by "    ;)
	end
	if loadfile(sPathToForbPat) then
		dofile(sPathToForbPat)
	else
		os.execute("mkdir \""..Core.GetPtokaXPath().."scripts/Antiadv/") --      
		WriteTable(forbidden_patterns, "forbidden_patterns", sPathToForbPat)
	end    
	if loadfile(sPathToAllowedPat) then
        dofile(sPathToAllowedPat)
	else
		os.execute("mkdir \""..Core.GetPtokaXPath().."scripts/Antiadv/") --      
		WriteTable(allowed_patterns, "allowed_patterns", sPathToAllowedPat)
	end 
	--!!!   !!!
	if loadfile(sPathToAntimat) then
		dofile(sPathToAntimat)
	else
		os.execute("mkdir \""..Core.GetPtokaXPath().."scripts/Antiadv/") --      
		WriteTable(antimat_pat, "antimat_pat", sPathToAntimat)
	end    
	if loadfile(sPathToExToAntimat) then
        dofile(sPathToExToAntimat)
	else
		os.execute("mkdir \""..Core.GetPtokaXPath().."scripts/Antiadv/") --      
		WriteTable(exceptions_pat, "exceptions_pat", sPathToExToAntimat)
	end 
	-- !!!   !!!
	if loadfile(sPathToConf) then
        dofile(sPathToConf)
	end
end

--     cp1251   

function string.lower2(message)
    return message:gsub("([-])",
		function(str)
			return string.char(str:byte()+32)
		end):gsub("", ""):lower()
end

--  , ,   ,            (captures)

local function gfind_patterns(string_, patterns)
	return coroutine.wrap(function ()
	for _, pattern in ipairs(patterns) do
		local i = 1
		while true do
			local results = {string_:find(pattern, i)}
			if not results[1] then
				break
			end
			i = results[2] + 1
			coroutine.yield(unpack(results))
		end
	end
	end)
end

-- ""         

local function collect_results(iterator)
	local all_results = {}
	while true do
		local results = {iterator()}
		if not results[1] then
			break
		end
		table.insert(all_results, results)
	end
	return all_results
end

--  true       forbidden_patterns     allowed_patterns,   false

local function is_forbidden(message, forbidden_patterns, allowed_patterns, antimat_pat, exceptions_pat)
	local allowed_indexes
	for start, end_ in gfind_patterns(message, forbidden_patterns, antimat_pat) do
		if not allowed_indexes then
			allowed_indexes = collect_results(gfind_patterns(message, allowed_patterns, exceptions_pat))
		end
		local forbid = true
		for _, indexes in ipairs(allowed_indexes) do
			if start >= indexes[1] and end_ <= indexes[2] then
				forbid = false
				break
			end
		end
		if forbid then
			return true
		end
	end
	return false
end

--     

function ChatArrival(user,data)
	local message = data:match("%b<>%s*(.+)|$"):gsub("[]", "")
	if message and  tProfiles[user.iProfile]==0 then
		if #message >= conf.min_size then
			message = string.lower2(message):gsub("[]", "")
			if is_forbidden(message, forbidden_patterns, allowed_patterns, antimat_pat, exceptions_pat) then
				if conf.op_info==1 then
					saverep(os.date("%d-%m-%Y/%H:%M:%S").." ***      : Nick:  "..user.sNick.."  IP:  "..user.sIP .."  :  "..tostring(IP2Country.GetCountryName(user)).."  "..block_message[4]..message, Log)
					Core.SendPmToOps(sBot, ("*** !!!    : Nick:  "..user.sNick.."  IP:  "..user.sIP .."  :  "..tostring(IP2Country.GetCountryName(user)).."  "..block_message[4]..message))
				end
				if conf.block_all_mode==0 then
					Core.SendToUser(user,"<"..sBot.."> *** "..block_message[2]..conf.ban_time.." .")
					BanMan.TempBan(user,conf.ban_time,"","",false)
					return true
				end
				if conf.block_all_mode==1 then
					Core.SendToUser(user,"<"..sBot.."> ***  "..block_message[3])
					Core.Disconnect(user)
					return true
				end
				if conf.block_all_mode==2 then
					Core.SendToUser(user, "<"..sBot.."> ***  "..block_message[1])
					return true
				end
				if conf.block_all_mode==3 then
					Core.SendToUser(user, ("<%s> %s"):format(user.sNick, message))    
					return true
				end
				if conf.block_all_mode==4 then
				end
			end
		end
	end
	Core.GetUserData(user, 11)
	if user.bOperator then
		data = data:sub(1, -2)
		local sCmd = data:match"^%b<> !(%S+)"
		if sCmd then
			if sCmd == "addForbPat" then --   
				local sForbidden = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbidden then
					for _, v in ipairs(forbidden_patterns) do
						if sForbidden == v then
							Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."      ")
							return true
						end
					end
					table.insert(forbidden_patterns,sForbidden)
					WriteTable(forbidden_patterns, "forbidden_patterns", sPathToForbPat)
					Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."     ") --      
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !addForbPat myhub.ru")
				end
			elseif sCmd == "addAllPat" then --  
				local sForbidden = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbidden then
					for _, v in ipairs(allowed_patterns) do
						if sForbidden == v then
							Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."      ")
							return true
						end
					end
					table.insert(allowed_patterns,sForbidden)
					WriteTable(allowed_patterns, "allowed_patterns", sPathToAllowedPat)
					Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."     ") --      
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !addAllPat myhub.ru")
				end
			elseif sCmd == "showForbPat" then --       ()
				if loadfile(sPathToForbPat) then
					dofile(sPathToForbPat)
				end
				local msg = "\n"
					if #forbidden_patterns > 0 then
				for i, v in ipairs(forbidden_patterns) do
					msg = msg .. "\n \t "..i.." \t"..v
					end
				else
					msg = msg .. "\n\t\t~    ~\n"
				end
				Core.SendToUser(user, "<"..sBot.."> \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\t\t\t \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" ..msg)
			elseif sCmd == "showAllPat" then --       ()
				if loadfile(sPathToAllowedPat) then
					dofile(sPathToAllowedPat)
				end
				local msg = "\n"
					if #allowed_patterns > 0 then
				for i, v in ipairs(allowed_patterns) do
					msg = msg .. "\n \t "..i.." \t"..v 
					end
				else
					msg = msg .. "\n\t\t~    ~\n"
				end
				Core.SendToUser(user, "<"..sBot..">\n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\t\t\t \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" ..msg) ---
			elseif sCmd == "delForbPat" then --    
				local sForbidden = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbidden then
					local num
					for i,v in ipairs(forbidden_patterns) do
						if v == sForbidden then
							num = i
							break
						end
					end
					if num then
						table.remove(forbidden_patterns,num)
						WriteTable(forbidden_patterns, "forbidden_patterns", sPathToForbPat)
						Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."      ") --      
					else
						Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."     ")
					end
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !delForbPat myhub.ru")
				end --
			elseif sCmd == "delAllPat" then --    
				local sForbidden = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbidden then
					local num
					for i,v in ipairs(allowed_patterns) do
						if v == sForbidden then
							num = i
							break
						end
					end
					if num then
						table.remove(allowed_patterns,num)
						WriteTable(allowed_patterns, "allowed_patterns", sPathToAllowedPat)
						Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."      ") --      
					else
						Core.SendToUser(user, "<"..sBot..">   "..sForbidden.."     ")
					end
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !delAllPat myhub.ru")
				end --
		elseif sCmd == "addMatPat" then --    (!!!  !!!)
				local sForbiddenAntimat = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbiddenAntimat then
					for _, v in ipairs(antimat_pat) do
						if sForbiddenAntimat == v then
							Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."      ")
							return true
						end
					end
					table.insert(antimat_pat,sForbiddenAntimat)
					WriteTable(antimat_pat, "antimat_pat", sPathToAntimat)
					Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."     ") --      
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !addMatPat ")
				end
			elseif sCmd == "addGoodPat" then --  
				local sForbiddenAntimat = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbiddenAntimat then
					for _, v in ipairs(exceptions_pat) do
						if sForbiddenAntimat == v then
							Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."       ")
							return true
						end
					end
					table.insert(exceptions_pat,sForbiddenAntimat)
					WriteTable(exceptions_pat, "exceptions_pat", sPathToExToAntimat)
					Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."      ") --      
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !addGoodPat ")
				end
			elseif sCmd == "showMatPat" then --       ()
				if loadfile(sPathToAntimat) then
					dofile(sPathToAntimat)
				end
				local msg = "\n"
					if #antimat_pat > 0 then
				for i, v in ipairs(antimat_pat) do
					msg = msg .. "\n \t "..i.." \t"..v
					end
				else
					msg = msg .. "\n\t\t~      ~\n"
				end
				Core.SendToUser(user, "<"..sBot.."> \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\t\t\t \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" ..msg)
			elseif sCmd == "showGoodPat" then --       ()
				if loadfile(sPathToExToAntimat) then
					dofile(sPathToExToAntimat)
				end
				local msg = "\n"
					if #exceptions_pat > 0 then
				for i, v in ipairs(exceptions_pat) do
					msg = msg .. "\n \t "..i.." \t"..v 
					end
				else
					msg = msg .. "\n\t\t~       ~\n"
				end
				Core.SendToUser(user, "<"..sBot..">\n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\t\t\t \n\t~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" ..msg) ---
			elseif sCmd == "delMatPat" then --    
				local sForbiddenAntimat = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbiddenAntimat then
					local num
					for i,v in ipairs(antimat_pat) do
						if v == sForbiddenAntimat then
							num = i
							break
						end
					end
					if num then
						table.remove(antimat_pat,num)
						WriteTable(antimat_pat, "antimat_pat", sPathToAntimat)
						Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."       ( )") --      
					else
						Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."       ")
					end
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !delMatPat ")
				end --
			elseif sCmd == "delGoodPat" then --    
				local sForbiddenAntimat = data:match"^%b<> !%S+%s+(%S+)$"
				if sForbiddenAntimat then
					local num
					for i,v in ipairs(exceptions_pat) do
						if v == sForbiddenAntimat then
							num = i
							break
						end
					end
					if num then
						table.remove(exceptions_pat,num)
						WriteTable(exceptions_pat, "exceptions_pat", sPathToExToAntimat)
						Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."       ") --      
					else
						Core.SendToUser(user, "<"..sBot..">   "..sForbiddenAntimat.."      ")
					end
				else
					Core.SendToUser(user, "<"..sBot..">   . :\n\t\t !delGoodPat ")
				end -- !!!   !!!
			elseif sCmd == "showPat" then --   
				Core.SendPmToUser(user, sBot, "\r\n\t\t :\n"..
								"\t%d+%.%d+%.%d+%.%d+ -  ip \n"..
								"\t%p -  \n"..
								"\t%s -  \n"..
								"\t%s - 1  \n"..
								"\t%s+ - 1    \n"..
								"\t%s- - 0    \n"..
								"\t%s* - 0    \n"..
								"\t%s? - 0  1  \n"..
								"\t%w  [A-Za-z0-9]\n"..
								"\t%d  [0-9]\n"..
								"\t       http://mydc.ru/topic266.html\n")
			elseif sCmd == "advconf" then
				local name,value = data:match"^%b<> !%S+%s+(%S+)%s+(%d+)$"
				if name then
					if conf[name] then
						conf[name] = tonumber(value)
						SaveConf()
						Core.SendToUser(user, "<"..sBot..">  "..name.." .   - "..conf[name])
					else
						Core.SendToUser(user, "<"..sBot..">  "..name.."  ")
					end
				else
					Core.SendToUser(user, "<"..sBot..">   .")
				end
			else
				return false --  ,   .    
			end
			return true
		end
	else
		local msg = data:sub(#user.sNick+4,-1)
		local censored
		for _,pat in ipairs(antimat_pat) do
			msg = msg:gsub("[--a-zA-Z]*"..pat.."[--a-zA-Z]*",function(word)
				for _,pat2 in ipairs(exceptions_pat) do
					if word:find(pat2) then
					print(word)
						return word
					end
				end
				censored = true
				return "" --   
			end)
		end
		if censored then
			Core.SendToAll("<"..user.sNick.."> "..msg)
			return true
		end
	end
end

--     

function ToArrival(user,data)
	local message = data:match("%b<>%s*(.+)|$"):gsub("[]", "")
	local s,e,to,from,sNick,message = string.find(data, "%$To:%s(%S+)%sFrom:%s(%S+)%s$<(%S+)%>%s(.*)$")
	local tToUser = Core.GetUser(to)
	if tToUser and message and tProfiles[user.iProfile]==0 and tProfiles[tToUser.iProfile]==0 then
		local msg = message
		message = string.lower2(message):gsub("[]", "")
		if is_forbidden(message, forbidden_patterns, allowed_patterns, antimat_pat, exceptions_pat) then
			if conf.op_info==1 then
				saverep(os.date("%d-%m-%Y/%H:%M:%S").." ***      : Nick:  "..user.sNick.."  IP:  "..user.sIP .."  :  "..tostring(IP2Country.GetCountryName(user)).."  -   IP:  "..tToUser.sIP .."  Nick:  "..to.."  :  "..tostring(IP2Country.GetCountryName(tToUser)).." "..block_message[5]..":  "..message, Log)
				Core.SendPmToOps(sBot, ("*** !!!    : Nick:  "..user.sNick.."  IP:  "..user.sIP .."  :  "..tostring(IP2Country.GetCountryName(user)).."  -   IP:  "..tToUser.sIP .."  Nick:  "..to.."  :  "..tostring(IP2Country.GetCountryName(tToUser)).." "..block_message[5]..":  "..message))
			end
			if conf.block_pm_mode==0 then
				Core.SendToUser(user,"<"..sBot..">***  "..block_message[2]..conf.ban_time.." .")
				BanMan.TempBan(user,conf.ban_time,"","",false)
				return true
			end
			if conf.block_pm_mode==1 then
				Core.SendToUser(user,"<"..sBot..">***  "..block_message[3])
				Core.Disconnect(user)
				return true
			end
			if conf.block_pm_mode==2 then
				Core.SendPmToUser(user, to,"***  "..block_message[1])
				return true
			end
			if conf.block_pm_mode==3 then
				return true
			end
			if conf.block_pm_mode==4 then
			end
		end
		local censored
		for _,pat in ipairs(antimat_pat) do
			msg = msg:gsub("[--a-zA-Z]*"..pat.."[--a-zA-Z]*",function(word)
				for _,pat2 in ipairs(exceptions_pat) do
					if word:find(pat2) then
					print(word)
						return word
					end
				end
				censored = true
				return "" --   
			end)
		end
		if censored then
			Core.SendToUser(tToUser,"$To: "..to.." From: "..from.." $<"..from.."> "..msg)
			return true
		end
	end
	return false
end

function WriteTable(tTable, tablename, file)
	local handle = io.open(file, "w")
	Serialize(tTable, tablename, handle)
  	handle:close()
end

function SaveConf() --  
	local f = io.open(sPathToConf,"w")
	Serialize(conf,"conf",f)
	f:close()
end

function saverep(rez,file) --  
	local f = io.open(file,"a+")
	f:write(rez.."\n")
	f:flush()
	f:close()
end

function Serialize(tTable, sTableName, hFile, sTab)
	sTab = sTab or "";
	hFile:write(sTab..sTableName.." = {\n" );
	for key, value in pairs(tTable) do
		local sKey = (type(key) == "string") and string.format("[%q]",key) or string.format("[%d]",key);
		if(type(value) == "table") then
			Serialize(value, sKey, hFile, sTab.."\t");
		else
			local sValue = (type(value) == "string") and string.format("%q",value) or tostring(value);
			hFile:write(sTab.."\t"..sKey.." = "..sValue);
		end
		hFile:write(",\n");
	end
	hFile:write(sTab.."}");
end

function OnError(s) --    
	Core.SendToOpChat(s)
end